import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load_module, reload_module, get_stdout, sanitize
from functools import reduce
from random import randint

exercise = 'src.longer_string'

def format_tuple(d : tuple):
    return str(d).replace("'","")

@points('1.longer_string')
class LongerStringTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect =['a', 'b']):
            cls.module = load_module(exercise, 'en')

    def test_first_one_is_longer(self):
        values = [("rabbit", "duck"), ("python", "java"), ("popcorn", "candy"), ("superman", "zorro")]
        for test_case in values:
            with patch('builtins.input', side_effect = test_case):
                try:
                    reload_module(self.module)
                except:
                     self.assertTrue(False, f"Se till att ditt program fungerar korrekt med input {test_case}")
                out = get_stdout()
                output = out.split("\n")  
                corr = test_case[0] + " är längre"
                self.assertTrue(len(out) > 0, "Ditt program skriver inte ut något med input {}".format(test_case))
                self.assertTrue(len(output) == 1, f"Ditt program ska bara skriva ut en rad förutom att be om input från användaren, ditt programs utskrift finns nu i {len(output)} rader.")
                self.assertTrue(sanitize(corr) == sanitize(out), f"Utskriften är felaktig med input {test_case}: ditt programs utskrift är\n{out}\nnär korrekt utskrift är\n{corr}")

    def test_second_one_is_longer(self):
        values = [("first", "second"), ("short", "longer"), ("test", "testing"), ("xyz", "abcd")]
        for test_case in values:
            with patch('builtins.input', side_effect = test_case):
                try:
                    reload_module(self.module)
                except:
                     self.assertTrue(False, f"Se till att ditt program fungerar korrekt med input {test_case}")
                out = get_stdout()
                output = out.split("\n")
                corr = test_case[1] + " är längre"
                self.assertTrue(len(out) > 0, "Ditt program skriver inte ut något med input {}".format(test_case))
                self.assertTrue(len(output) == 1, f"Ditt program ska bara skriva ut en rad förutom att be om input från användaren, ditt programs utskrift finns nu i {len(output)} rader.")
                self.assertTrue(sanitize(corr) == sanitize(out), f"Utskriften är felaktig med input {test_case}: ditt programs utskrift är\n{out}\nnär korrekt utskrift är\n{corr}")

    def test_equal_length(self):
        values = [("tik", "tok"), ("jack", "lisa"), ("abcd", "abcd"), ("sweet", "candy")]
        for test_case in values:
            with patch('builtins.input', side_effect = test_case):
                reload_module(self.module)
                out = get_stdout()
                output = out.split("\n")
                corr = "Strängarna är lika långa"
                self.assertTrue(len(out) > 0, "Ditt program skriver inte ut något med input {}".format(test_case))
                self.assertTrue(len(output) == 1, f"Ditt program ska bara skriva ut en rad förutom att be om input från användaren, ditt programs utskrift finns nu i {len(output)} rader.")
                self.assertTrue(sanitize(corr) == sanitize(out), f"Utskriften är felaktig med input {test_case}: ditt programs utskrift är\n{out}\nnär korrekt utskrift är\n{corr}")

if __name__ == '__main__':
    unittest.main()